__author__ = "Lukas Leufen"
__date__ = '2020-06-29'

from mlair.workflows import DefaultWorkflow
import inspect


def run(stations=None,
        train_model=None, create_new_model=None,
        window_history_size=None,
        experiment_date="testrun",
        variables=None, statistics_per_var=None,
        start=None, end=None,
        target_var=None, target_dim=None,
        window_lead_time=None,
        dimensions=None,
        interpolation_method=None, interpolation_dim=None, interpolation_limit=None,
        train_start=None, train_end=None, val_start=None, val_end=None, test_start=None, test_end=None,
        use_all_stations_on_all_data_sets=None, fraction_of_train=None,
        experiment_path=None, plot_path=None, forecast_path=None, bootstrap_path=None, overwrite_local_data=None,
        sampling=None,
        permute_data_on_training=None, extreme_values=None, extremes_on_right_tail_only=None,
        transformation=None,
        train_min_length=None, val_min_length=None, test_min_length=None,
        evaluate_bootstraps=None, number_of_bootstraps=None, create_new_bootstraps=None,
        plot_list=None,
        model=None,
        batch_size=None,
        epochs=None,
        data_handler=None,
        **kwargs):

    params = inspect.getfullargspec(DefaultWorkflow).args
    kwargs_default = {k: v for k, v in locals().items() if k in params and v is not None}

    workflow = DefaultWorkflow(**kwargs_default, **kwargs)
    workflow.run()


if __name__ == "__main__":
    from mlair.model_modules.model_class import MyBranchedModel
    run(statistics_per_var={'o3': 'dma8eu', "temp": "maximum"}, train_model=True,
        create_new_model=True, model=MyBranchedModel, station_type="background")
